#include "validation.h"
#include <string>

std::string alphabet = "abcdefghijklmnopqrstuvwxyz0123456789";

int main(int argc, char **argv)
{
    // Set up the input and answer streams.
    std::ifstream in(argv[1]);
    std::ifstream ans(argv[2]);
    OutputValidator v(argc, argv);

    // read pairs of song: artist separated by space into a hashmap
    std::string artist;
    std::string song;

    std::map<std::string, std::string> songs;
    int song_count;
    in >> song_count;

    while (in >> artist >> song)
    {
        songs[song] = artist;
    }

    std::string last_artist = "";

    // iterate over songs in validator
    for (int i = 0; i < song_count; i++)
    {
        std::string song = v.read_string("song", 1, 20, alphabet);

        v.newline();

        // check if song is in hashmap
        if (songs.find(song) == songs.end())
            v.check(false, "Song ", song, " is not in the input file, or was already consumed.");

        std::string current_artist = songs[song];
        v.check(current_artist != last_artist, "Song ", song, " is by the same artist (", current_artist, ") as the previous song.");
        last_artist = current_artist;
        songs.erase(song);
    }
}
