#include "validation.h"
#include<cmath>
#include<iterator>
#include<map>
#include<set>

using namespace std;

int nDoors;
set<int> rooms[1005]; // Note that this is an ordered set
map<int, pair<int, int>> doors;

void handleInaccessibleDoor(OutputValidator& v)
{
    v.WA("picked door that is inaccessible from current room");
}

void handleTimeout(OutputValidator& v)
{
    v.WA("Solution went through more doors than limit allows");
}



int main(int argc, char **argv) {
    // Set up the input and answer streams.
    std::ifstream in(argv[1]);
    std::ifstream ans(argv[2]); // Only for custom checker.
    OutputValidator v(argc, argv);

    int firstRoom;
    int finalRoom;

    in >> nDoors;
    in >> firstRoom;
    in >> finalRoom;

    int door;
    int room1;
    int room2;

    for(int i = 0; i < nDoors; i++)
    {
        in >> door;
        in >> room1;
        in >> room2;
        doors.insert ({ door, make_pair(room1, room2) });
        rooms[room1].insert(door);
        rooms[room2].insert(door);
    }

    cout << nDoors << endl;
    cerr << nDoors << endl;
    int doorPicked;
    int currentRoom = firstRoom;
    int doorsGoneThrough = 0;

    while (currentRoom != finalRoom)
    {
        cout << rooms[currentRoom].size() << endl;
        cerr << rooms[currentRoom].size() << endl;

        set<int> currentDoors = rooms[currentRoom]; // Note that this is an ordered set
        unsigned long doorIndex = 0;
        for (int door : rooms[currentRoom])
        {
            cout << door;
            cerr << door;
            // This looks really stupid but it's the easiest way to (1) not get a trailing space and (2) end with `endl`
            if (doorIndex == currentDoors.size() - 1)
            {
                cout << endl;
                cerr << endl;
            }
            else
            {
                cout << " ";
                cerr << " ";
            }
            doorIndex++;
        }

        int doorPicked = v.read_integer("doorPicked", 1, 1000);
        cerr << doorPicked << " PICKED"<< endl;
        if(!rooms[currentRoom].contains(doorPicked)) handleInaccessibleDoor(v);
        pair roomsConnectedByDoor = doors.find(doorPicked)->second;
        if(roomsConnectedByDoor.first == currentRoom) currentRoom = roomsConnectedByDoor.second;
        else currentRoom = roomsConnectedByDoor.first;
        doorsGoneThrough ++;
        if (doorsGoneThrough > nDoors * 5) handleTimeout(v);
        cerr << currentRoom <<" CURRENT_ROOM"<< endl;
    }

}
