import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class JeroenTranscribed {
    static double dist(double[] a, double[] b) {
        double dx = a[0] - b[0], dy = a[1] - b[1];
        return sqrt(dx * dx + dy * dy);
    }

    static double get(double[] a, double[] b, double[] c) {
        return dist(a, b) + dist(b, c) + dist(a, c);
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int n = sc.nextInt();
        double[][] pts = new double[n][2];
        for (int i = 0; i < n; i++) {
            pts[i][0] = sc.nextDouble();
            pts[i][1] = sc.nextDouble();
        }
        // random
        double ans = 1e18;
        Arrays.sort(pts, Comparator.comparingDouble(pt -> pt[0]));
        for (int i = 0; i < n; ++i) {
            for (int j = max(0, i - 100); j < i; ++j) {
                for (int k = j + 1; k < i; ++k) {
                    ans = min(ans, get(pts[i], pts[j], pts[k]));
                }
            }
        }
        System.out.println(ans);
    }
}