import java.util.*

fun main() {
    val (h, w) = readln().split(" ").map { it.toInt() }
    val grid = System.`in`.bufferedReader().lineSequence().map {
        it.toCharArray()
    }.toList()

    val u = Array(h, { y -> Array(w, { y - 1 }) })
    val d = Array(h, { y -> Array(w, { y + 1 }) })
    val l = Array(h, { Array(w, { x -> x - 1 }) })
    val r = Array(h, { Array(w, { x -> x + 1 }) })

    // border
    for (x in 0 until w) d[h - 1][x] = -1
    for (y in 0 until h) r[y][w - 1] = -1

    val q = Stack<Pair<Int, Int>>()
    for (y in 0 until h) {
        // l
        if (grid[y][0] == '<') q.push(Pair(y, 0))
        // r
        if (grid[y][w - 1] == '>') q.push(Pair(y, w - 1))
    }
    for (x in 0 until w) {
        // u
        if (grid[0][x] == '^') q.push(Pair(0, x))
        // d
        if (grid[h - 1][x] == 'v') q.push(Pair(h - 1, x))
    }


    val ans = StringBuilder()
    var count = 0
    while (q.size > 0) {
        val (cy, cx) = q.pop()

        ans.append(cy + 1).append(" ").append(cx + 1).append("\n")
        count += 1

        // update the adjacent neighbors
        if (u[cy][cx] != -1) {
            d[u[cy][cx]][cx] = d[cy][cx]
            if (d[cy][cx] == -1 && grid[u[cy][cx]][cx] == 'v')
                q.push(Pair(u[cy][cx], cx))
        }
        if (d[cy][cx] != -1) {
            u[d[cy][cx]][cx] = u[cy][cx]
            if (u[cy][cx] == -1 && grid[d[cy][cx]][cx] == '^')
                q.push(Pair(d[cy][cx], cx))
        }
        if (l[cy][cx] != -1) {
            r[cy][l[cy][cx]] = r[cy][cx]
            if (r[cy][cx] == -1 && grid[cy][l[cy][cx]] == '>')
                q.push(Pair(cy, l[cy][cx]))
        }
        if (r[cy][cx] != -1) {
            l[cy][r[cy][cx]] = l[cy][cx]
            if (l[cy][cx] == -1 && grid[cy][r[cy][cx]] == '<')
                q.push(Pair(cy, r[cy][cx]))
        }
    }

    println(if (count == h * w) ans else "impossible")
}
