import java.io.*;
import java.util.*;

public class LeonTranscribedByMaarten {
    public static class Pair {
        int y, x;

        public Pair(int y, int x) {
            this.y = y;
            this.x = x;
        }
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

        int h = sc.nextInt();
        int w = sc.nextInt();
        sc.nextLine();
        char[][] grid = new char[h][];
        for (int y = 0; y < h; y++) {
            grid[y] = sc.next().toCharArray();
        }

        int[][] d = new int[h][w], u = new int[h][w], l = new int[h][w], r = new int[h][w];
        for (int y = 0; y < h; y++) {
            for (int x = 0; x < w; x++) {
                u[y][x] = y - 1;
                d[y][x] = y == h - 1 ? -1 : y + 1;
                l[y][x] = x - 1;
                r[y][x] = x == w - 1 ? -1 : x + 1;
            }
        }

        Stack<Pair> q = new Stack<>();
        for (int y = 0; y < h; ++y) {
            if (grid[y][0] == '<') q.push(new Pair(y, 0));
            if (grid[y][w - 1] == '>') q.push(new Pair(y, w - 1));
        }
        for (int x = 0; x < w; ++x) {
            if (grid[0][x] == '^') q.push(new Pair(0, x));
            if (grid[h - 1][x] == 'v') q.push(new Pair(h - 1, x));
        }

        StringBuilder ans = new StringBuilder();
        int count = 0;

        while (q.size() > 0) {
            Pair curr = q.pop();
            int cy = curr.y;
            int cx = curr.x;
            ans.append(cy + 1).append(" ").append(cx + 1).append("\n");
            ++count;
            if (u[cy][cx] != -1) {
                d[u[cy][cx]][cx] = d[cy][cx];
                if (d[cy][cx] == -1 && grid[u[cy][cx]][cx] == 'v') {
                    q.push(new Pair(u[cy][cx], cx));
                }
            }

            if (d[cy][cx] != -1) {
                u[d[cy][cx]][cx] = u[cy][cx];
                if (u[cy][cx] == -1 && grid[d[cy][cx]][cx] == '^') {
                    q.push(new Pair(d[cy][cx], cx));
                }
            }

            if (l[cy][cx] != -1) {
                r[cy][l[cy][cx]] = r[cy][cx];
                if (r[cy][cx] == -1 && grid[cy][l[cy][cx]] == '>') {
                    q.push(new Pair(cy, l[cy][cx]));
                }
            }

            if (r[cy][cx] != -1) {
                l[cy][r[cy][cx]] = l[cy][cx];
                if (l[cy][cx] == -1 && grid[cy][r[cy][cx]] == '<') {
                    q.push(new Pair(cy, r[cy][cx]));
                }
            }
        }

        System.out.println(count == h * w ? ans : "impossible");
    }
}
