import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Stack;

public class LeonTranscribedByVerwoerd {
    public static void main(String[] args) throws IOException {
        var input = new BufferedReader(new InputStreamReader(System.in));
        var line = input.readLine().split(" ");
        var h = Integer.parseInt(line[0]);
        var w = Integer.parseInt(line[1]);
        var grid = new char[h][w];
        for (int y = 0; y < h; y++) {
            grid[y] = input.readLine().toCharArray();
        }
        var u = new int[h][w];
        var d = new int[h][w];
        for (int y = 0; y < h; y++) {
            Arrays.fill(u[y], y - 1);
            Arrays.fill(d[y], y + 1);
        }

        var l = new int[h][w];
        var r = new int[h][w];
        for (int y = 0; y < h; y++) {
            for (int x = 0; x < w; x++) {
                l[y][x] = x - 1;
                r[y][x] = x + 1;
            }
        }

        // border
        for (int x = 0; x < w; x++) d[h - 1][x] = -1;
        for (int y = 0; y < h; y++) r[y][w - 1] = -1;


        var q = new Stack<Pair>();
        for (int y = 0; y < h; y++) {
            // l
            if (grid[y][0] == '<') q.push(new Pair(y, 0));
            // r
            if (grid[y][w - 1] == '>') q.push(new Pair(y, w - 1));
        }
        for (int x = 0; x < w; x++) {
            // u
            if (grid[0][x] == '^') q.push(new Pair(0, x));
            // d
            if (grid[h - 1][x] == 'v') q.push(new Pair(h - 1, x));
        }

        var ans = new StringBuilder();
        var count = 0;
        while (!q.isEmpty()) {
            var point = q.pop();
            var cy = point.first;
            var cx = point.second;

            ans.append(cy + 1).append(" ").append(cx + 1).append("\n");
            count++;

            // update the adjacent neighbors
            if (u[cy][cx] != -1) {
                d[u[cy][cx]][cx] = d[cy][cx];
                if (d[cy][cx] == -1 && grid[u[cy][cx]][cx] == 'v')
                    q.push(new Pair(u[cy][cx], cx));
            }
            if (d[cy][cx] != -1) {
                u[d[cy][cx]][cx] = u[cy][cx];
                if (u[cy][cx] == -1 && grid[d[cy][cx]][cx] == '^')
                    q.push(new Pair(d[cy][cx], cx));
            }
            if (l[cy][cx] != -1) {
                r[cy][l[cy][cx]] = r[cy][cx];
                if (r[cy][cx] == -1 && grid[cy][l[cy][cx]] == '>')
                    q.push(new Pair(cy, l[cy][cx]));
            }
            if (r[cy][cx] != -1) {
                l[cy][r[cy][cx]] = l[cy][cx];
                if (l[cy][cx] == -1 && grid[cy][r[cy][cx]] == '<')
                    q.push(new Pair(cy, r[cy][cx]));
            }
        }

        System.out.println((count == h * w) ? ans : "impossible");
    }

    private record Pair(int first, int second) {
    }
}
