import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.List;

public class Verwoerd {
    public static void main(String[] args) throws IOException {
        var input = new BufferedReader(new InputStreamReader(System.in));
        var line = input.readLine().split(" ");
        var n = Integer.parseInt(line[0]);
        var k = Integer.parseInt(line[1]);
        var boxes = Arrays.stream(input.readLine().split(" ")).map(Long::parseLong).toList();
        System.out.println(getMinimumSize(boxes, n, k));
    }

    private static int getRestarts(List<Long> boxes, int n, long k) {
        var sum = 0L;
        var restarts = 0;
        for (int i = 0; i < n; i++) {
            var x = boxes.get(i);
            sum += x;
            if (sum > k) {
                sum = x;
                restarts++;
            }
        }
        return restarts;
    }

    private static long getMinimumSize(List<Long> boxes, int n, int k) {
        var left = 0L;
        var right = 0L;
        for (int i = 0; i < n; i++) {
            left = Math.max(left, boxes.get(i));
            right += boxes.get(i);
        }

        var result = -1L;
        while (left <= right) {
            var mid = (left + right) / 2;
            if (getRestarts(boxes, n, mid) < k) {
                result = mid;
                right = mid - 1;
            } else left = mid + 1;
        }
        return result;
    }
}
