import java.util.PriorityQueue

/**
 * Find the subsequences of cats to create a team.
 *
 * Observation: if a subsequence is too long, switching 1 preference will guarantee the correct size.
 * Therefor keep combining the longest sequences(one change) until you are over team size and add one change if the team is too big.
 *
 * Observation: If a team is to big after a merge, it can become the the correct size in the same swap by picking someone
 * else in the line.
 *
 * The text here is a bit unclear, but once I started creating text for a clarification request, I figured out what the
 * problem was. I expect this will get many RTPSC requests often.
 */
fun main() {
  val (cats, size) = readln().split(" ").map { it.toInt() }
  val preferences = readln().split(" ").take(cats).map { it.toInt() - 1 }.toIntArray()
  var index = 0
  val teams = PriorityQueue<Int> { a, b -> b.compareTo(a) }
  val seen = BooleanArray(cats + 1) { false }
  while (index < preferences.size) {
    if (!seen[index]) {
      seen[index] = true
      var current = preferences[index]
      var teamSize = 1
      while (!seen[current]) {
        seen[current] = true
        teamSize++
        current = preferences[current]
      }
      if (teamSize == size) return println(0) // optimization: the perfect team exists already
      teams.add(teamSize)
    }
    index++
  }
  var swaps = 0
  var current = teams.poll()
  while (current < size) {
    current+= teams.poll()
    swaps++
  }
  if(swaps == 0 && current > size) swaps++ // corner case, there is a team that is bigger then requested in initial prefs
  println(swaps)
}
