import kotlin.system.exitProcess

/**
 * Online Graph Traversal, requiring n log n steps. to be taken.
 *
 * For the testing tool, please add the following details for kotlin:
 * # Kotlin
 * #   kotlinc solution.kt
 * #   python3 testing_tool.py -f 1.in kotlin solutionKt
 */
fun main() {
  val output = System.out.bufferedWriter()
  fun write(c: Int) {
    output.write("$c\n")
    output.flush()
  }

  val target = readln().toInt()

  val visited = BooleanArray(target + 1)
  fun dfs(door: Int = 0) {
    if(door!= 0) write(door)
    readln()
    val roomId = readln()
    val doors = roomId.split(" ").map { it.toInt() }
    if (doors.contains(target)) {
      write(target)
      exitProcess(0)
    }
    for(next in doors.filter { !visited[it] }) {
      visited[next] = true
      dfs(next)
    }
    write(door) // backtrack
    readln() // read the info of the last door
    readln()
  }
  dfs()
  error("Program exited abnormally")
}
