/**
 * Looking at the time limit and the limited input size, this smells like an exponential solution. The easier solution
 * does require some knowledge. `E[X+Y] = E[X]+E[Y]`. I will have 2 solutions, one knowing probability theory and one
 * not knowing probability theory, which is more likely for .
 *
 * Again the problem description seems to be disjoint from the problem statement. Consider the following text, which asks
 * the same, but stays in character. This will train people to read details from the problem statement, rather than skip
 * ahead to the simple problem description.
 *
 * One day, the king came up with a new game. Every player would
 * choose a number and then the king would roll all his dice at once.
 * The player whose choice is closest to the value of all numbers on
 * the dice wins. Since the king hates losing, he wanted to increase
 * his winning chances by always choosing the expected value of his
 * throw. The expected value of an event is the weighted average of all possible outcomes.
 *
 * Not very skilled with mathematics, the king has tasked you to write a program to give the weighted
 * outcome to the given dice
 *
 * Suggestion: add an example where the result is not `.5`, so people know if they have to formatting for rounding on not
 * in certain languages.
 *
 */
val WEIGHTED_DICE = DoubleArray(9) { (it + 1.0) / 2 }

fun main() {
  println(
    System.`in`.bufferedReader().lineSequence().drop(1).first().split(" ").sumOf { a -> WEIGHTED_DICE[a.toInt()] })
}

