/**
Binary search over the range i in [min(boxes), sum(boxes)].
Calculate the number of restarts with max weight i.
If the restarts < k, eliminate the right half else the left half.
 */
fun main() {
    val input = System.`in`.bufferedReader()
    val (n, k) = input.readLine().split(" ").map { it.toInt() }
    val boxes = input.readLine().split(" ").map { it.toLong() }
    println(boxes.getMinimumSize(n, k))
}

fun List<Long>.getRestarts(n: Int, k: Long): Int {
    var sum = 0L
    var restarts = 0
    (0 until n).forEach { i ->
        val x = get(i)
        sum += x
        if (sum > k) {
            sum = x
            restarts++
        }
    }
    return restarts
}

fun List<Long>.getMinimumSize(n: Int, k: Int): Long {
    var left = 0L
    var right = 0L
    (0 until n).forEach { i ->
        left = left.coerceAtLeast(get(i))
        right += get(i)
    }
    var result = -1L
    while (left <= right) {
        val mid = (left + right) / 2
        when {
            getRestarts(n, mid) < k -> {
                result = mid
                right = mid - 1
            }

            else -> left = mid + 1
        }
    }
    return result
}
