import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class Verwoerd2 {
    public static void main(String[] args) throws IOException {
        var input = new BufferedReader(new InputStreamReader(System.in));
        var n = Integer.parseInt(input.readLine());
        var songs = new HashMap<String, List<String>>();
        for (int i = 0; i < n; i++) {
            var line = input.readLine().split(" ");
            songs.putIfAbsent(line[0], new LinkedList<>());
            songs.get(line[0]).add(line[1]);
        }

        var queue = new PriorityQueue<List<String>>((o1, o2) -> o2.size() - o1.size());
        songs.entrySet().stream().sorted((o1, o2) -> o2.getValue().size() - o1.getValue().size()).map(Map.Entry::getValue).forEach(queue::add);
        var next = queue.poll();
        List<String> current;
        var result = new StringBuilder();
        while (!queue.isEmpty()) {
            current = next;
            next = queue.poll();
            result.append(current.remove(0)).append('\n');
            if (!current.isEmpty()) queue.add(current);
        }
        result.append(next.get(0));
        System.out.println(result);
    }

    record SongPair(String artist, String song) {
    }
}
