import java.io.*;
import java.util.*;


public class VerwoerdScanner {
    public static void main(String[] args) throws IOException {
        var input = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        var n = input.nextInt();
        var k = input.nextInt();
        var boxes = new ArrayList<Long>(n);
        for (int i = 0; i < n; i++) {
            boxes.add(input.nextLong());
        }
        System.out.println(getMinimumSize(boxes, n, k));
    }

    private static int getRestarts(List<Long> boxes, int n, long k) {
        var sum = 0L;
        var restarts = 0;
        for (int i = 0; i < n; i++) {
            var x = boxes.get(i);
            sum += x;
            if (sum > k) {
                sum = x;
                restarts++;
            }
        }
        return restarts;
    }

    private static long getMinimumSize(List<Long> boxes, int n, int k) {
        var left = 0L;
        var right = 0L;
        for (int i = 0; i < n; i++) {
            left = Math.max(left, boxes.get(i));
            right += boxes.get(i);
        }

        var result = -1L;
        while (left <= right) {
            var mid = (left + right) / 2;
            if (getRestarts(boxes, n, mid) < k) {
                result = mid;
                right = mid - 1;
            } else left = mid + 1;
        }
        return result;
    }
}
