/*
Problem Difficulty: 2 stars out of 5 stars

We can binary search the minimum weight capacity required and the only other things to do are the following:

1. The range that we are searching on is the maximum number given and the sum of all weights.
2. We can store the weights in a queue and we can add as many boxes as the current capacity (the capacity we are searching) is bigger or equal than current sum of weights + the weight from the front of the queue.
3. We also need to count the number of times we are resetting the current sum and if it is bigger than the number allowed this means that we have to increase the capacity.

Complexity: nlogn
*/

#include <iostream>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>

using namespace std;

#define int long long

const int NMAX=1e5+5;
int k;
int v[NMAX];

bool solve(queue<int>q,int limit)
{
    int i,kon=0;
    bool flag=true;
    long long sc=0;
    while(!q.empty())
    {
        sc=0;
        kon++;
        if(kon>k)
        {
            return false;
        }
        while(!q.empty() && (sc+q.front()<=limit))
        {
            sc+=q.front();
            q.pop();
        }

    }
    return true;
}

long long binsearch(int st,int dr,int n)
{
    int i,mij,ans=-1;
    queue<int>q;
    for(i=1;i<=n;i++)
        q.push(v[i]);
    while(st<=dr)
    {
        mij=st+dr;
        mij/=2;
        if(solve(q,mij)==true)
        {
            ans=mij;
            dr=mij-1;
        }
        else
            st=mij+1;
    }
    if(ans==-1)
        ans=dr;
    return ans;
}

signed main()
{
    int n,i,j,s=0,maxi=0;
    cin>>n>>k;
    for(i=1;i<=n;i++)
    {
        cin>>v[i];
        s+=v[i];
        maxi=max(maxi,v[i]);
    }
    cout<<binsearch(maxi,s,n);
    return 0;
}
