#include <iostream>
#include <vector>
#include <array>
#include <complex>
using namespace std;

#define X real()
#define Y imag()
using pt = complex<short>;

const string sdir = ">v<^";
const pt dir[] = {{0,1},{1,0},{0,-1},{-1,0}};
const int mxN = 2000;

int n,m;
bool inside(pt p) {
    return 0<=p.X and p.X<n and 0<=p.Y and p.Y<m;
}

array<pt,mxN> ptr[4];
char g[mxN][mxN+1];
int main() {
    cin.tie(NULL)->sync_with_stdio(false);
    cin >> n >> m;
    for(int i=0;i<n;++i) {
        cin >> g[i];
    }
    vector<pt> q;
    for(int i=0;i<n;++i) {
        ptr[0][i] = {i,0};
        ptr[2][i] = {i,m-1};
    }
    for(int i=0;i<m;++i) {
        ptr[1][i] = {0,i};
        ptr[3][i] = {n-1,i};
    }
    auto update = [&](pt p) {
        array<int,2> coords = {p.X,p.Y};
        for(int i=0;i<4;++i) {
            pt& at = ptr[i][coords[i%2]];
            while(inside(at+dir[i]) and g[at.X][at.Y]=='.') {
                at+=dir[i];
            }
            if(g[at.X][at.Y]==sdir[(i+2)%4]) {
                g[at.X][at.Y]='*';
                q.push_back(at);
            }
        }
    };
    for(int i=0;i<n;++i) update({i,0});
    for(int i=0;i<m;++i) update({0,i});
    for(int i=0;i<q.size();++i) {
        auto at = q[i];
        g[at.X][at.Y]='.';
        update(at);
    }
    if(q.size()!=n*m) {
        cout << "impossible\n";
    } else {
        for(auto& p : q) {
            cout << p.X + 1 << ' ' << p.Y + 1 << '\n';
        }
    }
}