from math import sqrt

n = int(input())
points = [tuple(map(float, input().split())) for _ in range(n)]

# determine block size
block_num = int(max(3., sqrt(len(points) / 3)))
block_width = 2000.00002 / block_num

# place all points into the correct grid square
grid = [[[] for _ in range(block_num)] for _ in range(block_num)]
for x, y in points:
    grid[int((y + 1000.00001) / block_width)][int((x + 1000.00001) / block_width)].append((x, y))

# iterate over all 3x3 blocks
lowest = 8000
for j in range(block_num - 2):
    for i in range(block_num - 2):
        # create vector with elements of 3x3 block
        tmp = [p for row in grid[j:j + 3] for ps in row[i:i + 3] for p in ps]

        # iterate over elements in 3x3 block
        if len(tmp) < 3: continue

        for ii, (ax, ay) in enumerate(tmp):
            for jj, (bx, by) in enumerate(tmp[:ii]):
                for cx, cy in tmp[:jj]:
                    lowest = min(lowest, sqrt((ax - bx) ** 2 + (ay - by) ** 2)
                                 + sqrt((ax - cx) ** 2 + (ay - cy) ** 2)
                                 + sqrt((bx - cx) ** 2 + (by - cy) ** 2))

print(lowest)
