#include "bits/stdc++.h"

using namespace std;

typedef std::vector<double> vd;
typedef std::vector<vd> vvd;
typedef std::vector<vvd> vvvd;

double check_size(double ax, double ay, double bx, double by, double cx, double cy){
    return std::sqrt((ax-bx)*(ax-bx) + (ay-by)*(ay-by)) + std::sqrt((ax-cx)*(ax-cx) + (ay-cy)*(ay-cy)) + std::sqrt((bx-cx)*(bx-cx) + (by-cy)*(by-cy));
}

double correct_answer(vd X, vd Y){
    // determine block size
    int block_num = std::max(3.,std::sqrt(X.size()/3.));
    double block_width = (double) 2000.00002/block_num;

    // place all points into the correct grid square
    vvvd gridX(block_num, vvd(block_num));
    vvvd gridY(block_num, vvd(block_num));

    for (int i=0; i<X.size(); i++){
        // indexes in the grid
        int tmpX = (X[i]+1000.00001)/block_width;
        int tmpY = (Y[i]+1000.00001)/block_width;

        gridX[tmpX][tmpY].push_back(X[i]);
        gridY[tmpX][tmpY].push_back(Y[i]);
    }

    // iterate over all 3x3 blocks

    double lowest = 8000;
    for (int i=0; i<block_num-2; i++){
        for (int j=0; j<block_num-2; j++){
            // create vector with elements of 3x3 block
            vd tmpX;
            vd tmpY;
            for (int k=i; k<i+3; k++){
                for (int l=j; l<j+3; l++){
                    tmpX.insert(tmpX.end(), gridX[k][l].begin(), gridX[k][l].end());
                    tmpY.insert(tmpY.end(), gridY[k][l].begin(), gridY[k][l].end());
                }
            }

            // iterate over elements in 3x3 block
            if (tmpX.size()<3) continue;

            for (int a=0; a<tmpX.size()-2; a++){
                for (int b=a+1; b<tmpX.size()-1; b++){
                    for (int c=b+1; c<tmpX.size(); c++){
                        lowest = std::min(lowest, check_size(tmpX[a], tmpY[a], tmpX[b], tmpY[b], tmpX[c], tmpY[c]));
                    }
                }
            }
        }
    }

    return lowest;
}



int main(){
    int n; cin>>n;

    vd xs(n),ys(n);

    for (int i=0; i<n; i++){
        cin >>xs[i]>>ys[i];
    }

    cout << std::setprecision(20) << correct_answer(xs,ys) << endl;
}