from collections import defaultdict
from itertools import zip_longest

# Strategy:
# - Sort artists by number of songs (descending)
# - Append sorted songs into one big lists
# - Fill odd positions from the start of `sorted_songs`, fill even positions from the middle of `sorted_songs`

n, songs = int(input()), defaultdict(list)

for artist, title in (input().split() for _ in range(n)): songs[artist].append(title)

sorted_songs = [t for titles in sorted(songs.values(), key=lambda titles: len(titles), reverse=True) for t in titles]

[print(*t) for t in zip_longest(sorted_songs[:n // 2], sorted_songs[n // 2:], fillvalue="")]
