#include <iostream>
#include <cassert>

const int MAX_N = 1000000;
int armor[MAX_N + 1];

void add_simple_range(int l, int r) {
  armor[l]++;
  armor[r + 1]--;
}

void add_range(int l, int r) {
  if (l <= r)
    add_simple_range(l, r);
  else {
    add_simple_range(l, MAX_N - 1);
    add_simple_range(0, r);
  }
}

int main() {
  std::cin.tie(NULL);
  std::ios_base::sync_with_stdio(false);

  int n, m;

  std::cin >> n >> m;

  assert(1 <= n && n <= 1000000);
  assert(1 <= m && m <= 1000000);

  for (int i = 0; i < m; ++i) {
    int x, y;
    std::cin >> x >> y;
    
    assert(1 <= x && x <= n);
    assert(1 <= y && y <= n);
    
    x--;
    y--;


    if (x != y) {
      x = (x + 1) % n;
      add_range(x, y);
    }
  }

  int best = m + 1;
  for (int i = 0; i < n; ++i) {
    best = std::min(best, armor[i]);
//    if (armor[i] == 4248)
//      printf("Chosen %d\n", i);
    armor[i + 1] += armor[i];
  }

  std::cout << best << "\n";

  return 0;
}

