#include <bits/stdc++.h>

const int MAX_N = 10000;

struct Point {
  long double x, y;
} points[MAX_N];

bool cmp_x(Point a, Point b) {
  return a.x < b.x;
}

bool cmp_y(Point a, Point b) {
  return a.y < b.y;
}

long double dist(Point a, Point b) {
  return std::sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

const int TRIES = 100;

long double min_triangle(int n) {
  long double res = 1e9;
  for (int i = 0; i < n; ++i)
    for (int j = i + 1; j < n && j < i + TRIES; ++j)
      for (int k = j + 1; k < n && k < i + TRIES; ++k)
        res = std::min(res, dist(points[i], points[j]) + 
                            dist(points[j], points[k]) +
                            dist(points[k], points[i]));

  return res;
}

int main() {
  int n;
  std::cin >> n;
  for (int i = 0; i < n; ++i)
    std::cin >> points[i].x >> points[i].y;
  
  long double res = 1e9;
  std::sort(points, points + n, cmp_x);
  res = std::min(res, min_triangle(n));
  std::sort(points, points + n, cmp_y);
  res = std::min(res, min_triangle(n));

  printf("%.15Lf", res);

  return 0;
}

