"""
This is the ultimate optimal solution, the one that should work for all cases at all times.
The problem statement might be more relaxed, allowing other more trivial solutions to pass.
"""


from collections import defaultdict
from typing import DefaultDict, List,  Set


n_songs = int(input())

song_dict = {}


for _ in range(n_songs):
    artist, song_name = input().split(" ")
    song_dict.setdefault(artist, [])
    song_dict[artist].append(song_name)

count_brackets: DefaultDict[int, Set[str]] = defaultdict(set)

to_print = []

for artist, songs in song_dict.items():
    count_brackets[len(songs)].add(artist)


def print_from_artist(artist):
    lower_artist_bracket(artist)
    to_print.append(song_dict[artist].pop(0))


def lower_artist_bracket(artist):
    count = len(song_dict[artist])
    if artist in count_brackets[count]:
        count_brackets[count].remove(artist)
    if len(count_brackets[count]) == 0:
        del count_brackets[count]

    if count > 1:
        count_brackets[count-1].add(artist)


max_bracket = max(count_brackets.keys())
while max_bracket > 0:
    # print alternating artists
    if len(count_brackets[max_bracket]) == 1:
        max_artist = count_brackets[max_bracket].pop()
        if len(count_brackets) == 1:
            # means we got the last song of the last artist
            print_from_artist(max_artist)
            break

        second_max_bracket = sorted(
            k for k in count_brackets.keys() if k < max_bracket)[-1]

        artist = count_brackets[second_max_bracket].pop()
        print_from_artist(max_artist)
        print_from_artist(artist)

    else:
        current, count_brackets[max_bracket] = count_brackets[max_bracket], []
        for artist in current:
            print_from_artist(artist)

    max_bracket = max(count_brackets.keys()) if len(count_brackets) > 0 else 0


print("\n".join(to_print))
