# @EXPECTED_RESULTS@: ACCEPTED, WRONG_ANSWER
# Does not always fail, but when it does, it's because the grid is shifted by 1000 pixels.
# In that case, a triangle crossing the x- or y-axis is not found.
from math import sqrt


def smallest_triangle(ps):
    return min((sqrt((ax - bx) * (ax - bx) + (ay - by) * (ay - by))
                + sqrt((ax - cx) * (ax - cx) + (ay - cy) * (ay - cy))
                + sqrt((bx - cx) * (bx - cx) + (by - cy) * (by - cy))
                for i, (ax, ay) in enumerate(ps) for j, (bx, by) in enumerate(ps[:i]) for cx, cy in ps[:j]),
               default=1e9)


n = int(input())
points = [tuple(map(float, input().split())) for _ in range(n)]

k = 60 if n >= 5000 else 40 if n >= 2500 else 20 if n >= 1000 else 10
s = 2000 / k
grid = [[[] for _ in range(k)] for _ in range(k)]
for x, y in points: grid[int(y / s)][int(x / s)].append((x, y))
for l in range(3, k):
    ans = min(smallest_triangle([p for row in grid[y:y + l] for ps in row[x:x + l] for p in ps])
              for y in range(k - l + 1) for x in range(k - l + 1))
    if ans != 1e9: print(ans), exit()
