// @EXPECTED_RESULTS@: RUN_TIME_ERROR, WRONG_ANSWER
import java.util.PriorityQueue

/**
 * Find the subsequences of cats to create a team.
 *
 * Observation: if a subsequence is too long, switching 1 preference will guarantee the correct size.
 * Therefor keep combining the longest sequences(one change) until you are over team size and add one change if the team is too big.
 *
 * The text here is a bit unclear, but once I started creating text for a clarification request, I figured out what the
 * problem was. I expect this will get many RTPSC requests often.
 */
fun main() {
  val (cats, size) = readln().split(" ").map { it.toInt() }
  val preferences = readln().split(" ").take(cats).map { it.toInt() - 1 }.toIntArray()
  var index = 0
  val teams = PriorityQueue<Int> { a, b -> b.compareTo(a) }
  val seen = BooleanArray(size + 1) { false }
  while (index < preferences.size) {
    if (!seen[index]) {
      seen[index] = true
      var current = preferences[index]
      var teamSize = 1
      while (!seen[current]) {
        seen[current] = true
        teamSize++
        current = preferences[current]
      }
      teams.add(teamSize)
    }
    index++
  }
  var swaps = 0
  var current = 0
  while (current < size) {
    current += teams.poll()
    swaps++
  }
  if (current == size) swaps--
  println(swaps)
}
