// @EXPECTED_RESULTS@: TIME_LIMIT_EXCEEDED, WRONG_ANSWER
import kotlin.math.pow

/**
 * This problem looked hard to me, until if read that the points started stationary. The calculations are easier to
 * follow by using th example. Especially the conversion of units can be confusing.
 *
 * The Y is inverted! bad mojo. Y=0 should be on the bottom, not the top. The only place you can deduct this is from
 * the input data. Also explains why I thought the input was reversed order.
 */
const val ONE_SIXTh = 1.0 / 6
fun main() {
  fun Double.getSpeed() = times(0.000_000_001).pow(ONE_SIXTh)
  fun calculateTime(start: Double, end: Double, mass: Double): Double {
    val speed = mass.getSpeed()
    return (end - start) / speed
  }
  val (_, height) = readln().split(" ").map { it.toDouble() }
  val drops = System.`in`.bufferedReader().lineSequence()
    .flatMap { pair -> pair.split(" ").take(2).map { it.toDouble() }.zipWithNext() }
    .toList()
 
  val (h, t, m) = drops.fold(Triple(0.0, 0.0, 0.0)) { (height, time, mass), (s, y) ->
    if (height == 0.0) {
      Triple(y, time, s)
    } else {
      Triple(y, calculateTime(height, y, mass) + time, mass + s)
    }
  }
  println((t + calculateTime(h, height, m)) / 1000.0)

}
