/*
Problem difficulty: 2 stars out of 5 stars

First of all we need to use a map to keep track of the frequency of each artist and also we will need another map to keep track of each song from all artists. Now we are going to use a priority queue which is going to keep this frequencies and will remove 2 frequencies from the top of the priority queue and we will add them back decrementing them by 1. We will also add the artist corresponding to the frequencies removed into a queue and the only thing left is to search in our map the songs corresponding.

Complexity of the algorithm: O(n)
*/

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>
#include <set>

using namespace std;

const int NMAX=1e5+5;

struct elem{
    string artist;
    string song;
    int freq;
    bool operator<(const elem &other) const
    {
        return freq<other.freq;
    }
}v[NMAX];

queue<string>q;
priority_queue<elem>pq;
map<string,vector<string>>mp2;
map<string,int>mp;

int main()
{
    int n,m,i,j;
    cin>>n;
    for(i=1;i<=n;i++)
    {
        cin>>v[i].artist>>v[i].song;
        mp[v[i].artist]++;
        mp2[v[i].artist].push_back(v[i].song);
    }
    for(auto i:mp)
    {
        elem aux;
        aux.artist=i.first;
        aux.freq=i.second;
        pq.push(aux);
    }
    while(!pq.empty())
    {
        elem p=pq.top();
        pq.pop();
        p.freq--;
        q.push(p.artist);
        elem p2=pq.top();
        pq.pop();
        p2.freq--;
        q.push(p2.artist);
        if(p.freq!=0)
            pq.push(p);
        if(p2.freq!=0)
            pq.push(p2);
        if(pq.size()==1)
        {
            elem p=pq.top();
            pq.pop();
            q.push(p.artist);
            break;
        }
    }
    while(!q.empty())
    {
        string p=q.front();
        q.pop();
        cout<<mp2[p].back()<<" ";
        mp2[p].pop_back();
    }
    return 0;
}
