import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import static java.lang.Math.*;

public class VerwoerdCubicTLE {
    public static void main(String[] args) throws IOException {
        var input = new BufferedReader(new InputStreamReader(System.in));
        var n = Integer.parseInt(input.readLine());
        var points = new PointJava[n];
        for (
                int i = 0;
                i < n; i++) {
            var line = input.readLine().split(" ");
            points[i] = new PointJava(Double.parseDouble(line[0]), Double.parseDouble(line[1]));
        }

        var min = Double.MAX_VALUE;
        if (n == 3) {
            min = calculatePerimeter(points[0], points[1], points[2]);
        } else {
            for (int k = 0; k < n - 2; k++) {
                for (int l = k + 1; l < n - 1; l++) {
                    for (int m = l + 1; m < n; m++) {
                        min = min(min, calculatePerimeter(points[k], points[l], points[m]));
                    }
                }
            }
        }
        System.out.println(min);
    }

    private record PointJava(double x, double y) {
    }

    static double calculateDistance(PointJava a, PointJava b) {
        return sqrt(pow((a.x - b.x), 2) + pow(a.y - b.y, 2));
    }

    static double calculatePerimeter(PointJava a, PointJava b, PointJava c) {
        return calculateDistance(a, b) + calculateDistance(b, c) + calculateDistance(c, a);
    }
}
