import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.List;

import static java.lang.Math.max;
import static java.lang.Math.min;

public class VerwoerdQuadraticDPTLE {
    public static void main(String[] args) throws IOException {
        var input = new BufferedReader(new InputStreamReader(System.in));
        var line = input.readLine().split(" ");
        var n = Integer.parseInt(line[0]);
        var k = Integer.parseInt(line[1]);
        var boxes = Arrays.stream(input.readLine().split(" ")).map(Long::parseLong).toList();
        System.out.println(findMax(boxes, n, k));
    }

    private static long findMax(List<Long> boxes, int n, int k) {
        // initialize table
        var dp = new long[k + 1][n+1];
        // create cumulative sum table to avoid having to loop ove the list for every minOf operation
        var sum = new long[n + 1];
        for(int i=1; i <= n; i++) {
            sum[i] = sum[i-1] + boxes.get(i-1);
        }

        // base cases
        // only one divider -> cumulative sum
        if (n >= 0) System.arraycopy(sum, 1, dp[1], 1, n);

        // set of size 1 -> the first value
        var start = boxes.get(0);
        for (int i = 1; i <= k; i++) {
            dp[i][1] = start;
        }
        for (int i = 2; i <= k; i++) {
            for (int j = 2; j <= n; j++) {
                var min = Long.MAX_VALUE;
                for (int p = 1; p < j; p++) {
                    min = min(min, max(dp[i-1][p], sum[j]-sum[p]));
                }
                dp[i][j]=min;

            }
        }
        return dp[k][n];
    }
}
