/**
 * Problems with a lot of text also are easier than they look somehow. Basically some observations:
 * Levels with lower weapon requirement then current level can be ignored
 * It is faster to complete all levels and then return back for every level that you missed just once.
 * pitfall: The weapon received on the level can't get you the armour on the same level
 * pitfall: you don't have to start at level one
 *
 * This might be the easiest problems most teams will miss due to wall of text. Which is good.
 *
 * Note that Mega Man and Mega Man X might both trademarked as well.
 *
 * Note: might want to double-check for using US spelling (armor) or UK spelling (armour) as style for all problems.
 */
fun main() {
  val (n, m) = readln().split(" ").let {(a,b) -> a.toInt() to b.toInt() }

  val list = System.`in`.bufferedReader().lineSequence().take(m)
    .map { l -> l.split(" ").map { it.toInt() }.let { (a, b) -> a to b } }.toList()
  // only consider to start the levels where weapons are needed for armour
  // For debug, to level where to start replace `minOf` by `minBy`
  list.map { (it.first)}.minOf { k ->
//    println("$k: ${list.filter {    when {
//      k == it.first -> false
//      it.first < it.second -> k in it.first+1..it.second
//      it.first == it.second -> false
//      else ->  k !in it.second+1..it.first
//    } }}")
    list.count {
      when {
        k == it.first -> false
        it.first < it.second -> k in it.first + 1..it.second // redo when k in w < k <= a
        it.first == it.second -> false // never redo if the weapon is on the same level (verify this)
        else -> k !in it.second + 1..it.first // redo when k not in a < k <= w
      }
    }
  }.also { println(it) }
}
