import java.io.*;
import java.util.*;

public class VerwoerdTLE3 {
    public static void main(String[] args) throws IOException {
        var input = new BufferedReader(new InputStreamReader(System.in));
        var line = input.readLine().split(" ");
        var h = Integer.parseInt(line[0]);
        var w = Integer.parseInt(line[1]);
        var grid = new char[h][w];
        for (int y = 0; y < h; y++) {
            var row = input.readLine().toCharArray();
            grid[y] = row;
        }
        var topRow = new int[w];
        var bottomRow = new int[w];
        Arrays.fill(bottomRow, h - 1);
        var leftColumn = new int[h];
        var rightColumn = new int[h];
        Arrays.fill(rightColumn, w - 1);
        seen = new boolean[h][w];
        var total = 0;
        do {
            updates = 0;
            for (int y = 0; y < h; y++) {
                var xTmp = leftColumn[y];
                if (xTmp < w) {
                    var x = xTmp;
                    while (x < w && seen[y][x]) x++;
                    while (x < w && grid[y][x] == '<') {
                        register(x, y);
                        x++;
                    }
                    if (x != xTmp) leftColumn[y] = x;
                }
            }

            for (int x = 0; x < w; x++) {
                var yTmp = topRow[x];
                if (yTmp < h) {
                    var y = yTmp;
                    while (y < h && seen[y][x]) y++;
                    while (y < h && grid[y][x] == '^') {
                        register(x, y);
                        y++;
                    }
                    if (y != yTmp) topRow[x] = y;
                }
            }

            for (int y = 0; y < h; y++) {
                var xTmp = rightColumn[y];
                if (xTmp >= 0) {
                    var x = xTmp;
                    while (x >= 0 && seen[y][x]) x--;
                    while (x >= 0 && grid[y][x] == '>') {
                        register(x, y);
                        x--;
                    }
                    if (x != xTmp) rightColumn[y] = x;
                }
            }

            for (int x = 0; x < w; x++) {
                var yTmp = bottomRow[x];
                if (yTmp >= 0) {
                    var y = yTmp;
                    while (y >= 0 && seen[y][x]) y--;
                    while (y >= 0 && grid[y][x] == 'v') {
                        register(x, y);
                        y--;
                    }
                    if (y != yTmp) bottomRow[x] = y;
                }
            }
            total += updates;
        } while (updates > 0);
        if (total < h * w) System.out.println("impossible");
        else System.out.print(result);
    }

    static StringBuilder result = new StringBuilder();
    static boolean[][] seen;
    static int updates;

    public static void register(int x, int y) {
        result.append(y + 1).append(" ").append(x + 1).append("\n");
        seen[y][x] = true;
        updates++;
    }
}
