#include <cmath>
#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

typedef vector<double> vd;
typedef vector<vd> vvd;
typedef vector<vvd> vvvd;

double check_size(double ax, double ay, double bx, double by, double cx, double cy){
    return sqrt((ax - bx) * (ax - bx) + (ay - by) * (ay - by))
         + sqrt((ax - cx) * (ax - cx) + (ay - cy) * (ay - cy))
         + sqrt((bx - cx) * (bx - cx) + (by - cy) * (by - cy));
}

int main(){
    int n;
    cin >> n;
    vd xs(n), ys(n);
    for (int i = 0; i < n; i++) {
        cin >> xs[i] >> ys[i];
    }

    double lowest = 1e9;
    for (int a = 0; a < xs.size(); a++) {
        for (int b = 0; b < a; b++) {
            for (int c = 0; c < b; c++) {
                lowest = min(lowest, check_size(xs[a], ys[a], xs[b], ys[b], xs[c], ys[c]));
            }
        }
    }

    cout << setprecision(20) << lowest << endl;
}
