#include <iostream>
#include <string>
#include <vector>
#include <utility>
#include <algorithm>

const int MAX_N = 2000;

std::string matr[MAX_N];
std::vector<std::pair<int, int>> topsort;

bool visited[MAX_N][MAX_N];
bool instack[MAX_N][MAX_N];

int dl[] = { 0, 1, 0, -1};
int dc[] = { 1, 0,-1,  0};

int charToDir(char chr) {
  switch (chr) {
    case '>': return 0;
    case 'v': return 1;
    case '<': return 2;
    case '^': return 3;
  }

  return -1;
}

bool dfs(int l, int c, int n, int m) {
  instack[l][c] = true;
  visited[l][c] = true;

  int dir = charToDir(matr[l][c]);

  int ln = l + dl[dir];
  int cn = c + dc[dir];

  while (0 <= ln && ln < n && 0 <= cn && cn < m) {
    
    if (instack[ln][cn])
      return true;
    
    if (!visited[ln][cn] && dfs(ln, cn, n, m))
      return true;

    ln = ln + dl[dir];
    cn = cn + dc[dir];
  }
  
  topsort.push_back({l, c});
  instack[l][c] = false;
  return false;
}

int main() {
  int n, m;

  std::cin >> n >> m;

  for (int i = 0; i < n; ++i)
    std::cin >> matr[i];

  bool impossible = false;

  for (int l = 0; l < n; ++l)
    for (int c = 0; c < m; ++c)
      if (!visited[l][c] && dfs(l, c, n, m))
        impossible = true;

  if (impossible)
    std::cout << "impossible\n";
  else {
    for (auto it: topsort)
      std::cout << it.first + 1 << " " << it.second + 1 << "\n";
  }

  return 0;
}

