#!/usr/bin/env python3

h, w = map(int, input().split())
grid = [list(input()) for _ in range(h)]

topRow = [0] * w
bottomRow = [h - 1] * w
leftColumn = [0] * h
rightColum = [w - 1] * h
seen = [[False] * w for _ in range(h)]
updates = 1
total = 0
result = []


def register(x: int, y: int):
    global updates
    result.append((y + 1, x + 1))
    seen[y][x] = True
    updates += 1


iterations = 0
while updates:
    iterations += 1
    total += updates
    updates = 0
    # check left column '<'
    for y, xTmp in enumerate(leftColumn):
        if xTmp < w:
            x = xTmp
            # forward to the first not seen grid tile
            while x < w and seen[y][x]:
                x += 1
            while x < w and grid[y][x] == '<':
                # this tile can be removed
                register(x, y)
                x += 1

            if x != xTmp:
                leftColumn[y] = x

    # check top row for '^'
    for x, yTmp in enumerate(topRow):
        if yTmp < h:
            y = yTmp
            # forward to the first not seen grid tile
            while y < h and seen[y][x]:
                y += 1

            while y < h and grid[y][x] == '^':
                # this tile can be removed
                register(x, y)
                y += 1

            if y != yTmp:
                topRow[x] = y

    # check top right colums for '>'
    for y, xTmp in enumerate(rightColum):
        if xTmp >= 0:
            x = xTmp
            # forward to the first not seen grid tile
            while x >= 0 and seen[y][x]:
                x -= 1

            while x >= 0 and grid[y][x] == '>':
                # this tile can be removed
                register(x, y)
                x -= 1

            if x != xTmp:
                rightColum[y] = x

    # check bottom row for 'v'
    for x, yTmp in enumerate(bottomRow):
        if yTmp >= 0:
            y = yTmp
            # forward to the first not seen grid tile
            while y >= 0 and seen[y][x]:
                y -= 1

            while y >= 0 and grid[y][x] == 'v':
                # this tile can be removed
                register(x, y)
                y -= 1

            if y != yTmp:
                bottomRow[x] = y

if total < h * w:
    print("impossible")
else:
    for pos in result: print(*pos)
