import java.util.LinkedList

/**
 * Online Graph Traversal, requiring n log n steps. to be taken.
 *
 * For the testing tool, please add the following details for kotlin:
 * # Kotlin
 * #   kotlinc solution.kt
 * #   python3 testing_tool.py -f 1.in kotlin solutionKt
 */
fun main() {
  val output = System.out.bufferedWriter()
  fun write(c: Int) {
    output.write("$c\n")
    output.flush()
  }

  val target = readln().toInt()

  val visited = BooleanArray(target + 1)
  val queue = LinkedList<Int>()
  var lastTarget = 0
  while (true) {
    readln()
    val roomId = readln()
    val doors = roomId.split(" ").map { it.toInt() }

    if (doors.contains(target)) {
      write(target)
      break;
    }
    doors.filter { !visited[it] }.onEach { visited[it] = true }.toCollection(queue)
    val next = queue.first
    if (next == lastTarget) {
      queue.removeFirst()
    }
    lastTarget = next
    write(next)
  }
}
