/*
Problem Difficulty: 2 stars out of 5

The first step in solving this problem is based on the observation that if we have a string of size n with identical characters then the number of palindromes is going to be exactly n*(n+1)/2 (for e.g. aaaa contains exactly 10 palindromes) but in our worst case we will have to build a string with size 10^5 characters which contains 10^9 palindromes.

First 44720 characters of our string will be identical characters and now we have 10^9-44720*44721/2=38440 palindromes left. Due to the fact that we now can use 10^5-44720=55280 characters this means that we have enough characters to form palindromes of only 1 characters so we can repeat the sequence 'bcd' avoiding the creation of other palindromes.

e.g.:
13 -> aaaabcd
14 -> aaaabcdb

So what we have to do is to binary search the maximum length of the string that contains only identical characters and has the number of palindromes (n*(n+1)/2) <= s and then we are going to repeat the sequence 'bcd' forming the palindromes left.

Complexity: logn
*/

#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

#define int long long

signed main()
{
    int n,i,st,dr,mij,best=0;
    cin>>n;
    st=0,dr=44721;
    while(st<dr)
    {
       mij=st+dr;
       mij/=2;
       if(1LL*mij*(mij+1)/2==n)
       {
           best=mij;
           break;
       }
       else if(1LL*mij*(mij+1)/2<n)
           best=mij,st=mij+1;
       else
           dr=mij-1;
    }
    for(i=1;i<=best;i++)
        cout<<"a";
    int memo1=(n-1LL*best*(best+1)/2)/3;
    int memo2=(n-1LL*best*(best+1)/2)%3;
    for(i=1;i<=memo1;i++)
        cout<<"bcd";
    if(memo2==2)
        cout<<"bc";
    else if(memo2==1)
        cout<<"b";
    return 0;
}