#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <iomanip>

///#include <tryhardmode>
///#include <GODMODE::ON>

using namespace std;

const int NMAX=1e4+5;
const long double INF=-2e9;

struct coords{
    long double x;
    long double y;
}v1[NMAX],v2[NMAX],v[NMAX];

bool cmp1(coords a,coords b)
{
    if(a.x==b.x)
        return a.y<b.y;
    return a.x<b.x;
}

bool cmp2(coords a,coords b)
{
    if(a.y==b.y)
        return a.x<b.x;
    return a.y<b.y;
}

long double dista_euclid(coords a,coords b)
{
    long double dist=(long double)sqrt((long double)(a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
    return (long double)sqrt((double)((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y)));
}

long double solve_perimeter(coords a,coords b,coords c)
{
    long double peri;
    peri=dista_euclid(a,b)+dista_euclid(b,c)+dista_euclid(a,c);
    return peri;
}

map<pair<long double,long double>,coords>mp[5];
/*
    1->next on x-axis;
    2->previous on x-axis;
    3->next on y-axis;
    4->previous on y-axis;
*/

bool diff(long double a,long double b,int key)
{
    if(mp[key][make_pair(a,b)].x!=-INF && mp[key][make_pair(a,b)].y!=-INF)
        return true;
    return false;
}

map<long double,vector<long double>>samex;
map<long double,vector<long double>>samey;

int main()
{
    int n,i,j;
    long double mini=-INF;
    cin>>n;
    for(i=1;i<=n;i++)
    {
        cin>>v[i].x>>v[i].y;
        v1[i].x=v2[i].x=v[i].x;
        v1[i].y=v2[i].y=v[i].y;
        samex[v[i].x].push_back(v[i].y);
        samey[v[i].y].push_back(v[i].x);
        mp[1][make_pair(v[i].x,v[i].y)].x=mp[1][make_pair(v[i].x,v[i].y)].y=-INF;
        mp[2][make_pair(v[i].x,v[i].y)].x=mp[2][make_pair(v[i].x,v[i].y)].y=-INF;
        mp[3][make_pair(v[i].x,v[i].y)].x=mp[3][make_pair(v[i].x,v[i].y)].y=-INF;
        mp[4][make_pair(v[i].x,v[i].y)].x=mp[4][make_pair(v[i].x,v[i].y)].y=-INF;
    }
    sort(v1+1,v1+n+1,cmp1);
    sort(v2+1,v2+n+1,cmp2);
    for(i=1;i<=n;i++)
    {
        if(i!=1)
        {
            if(samex[v1[i-1].x].size()>1)
            {
                long double best=-INF;
                long double ind=0;
                for(auto j:samex[v1[i-1].x])
                {
                    if(j==v1[i].y)
                        continue;
                    coords aux;
                    aux.x=v1[i-1].x;
                    aux.y=j;
                    if(best>dista_euclid(v1[i],aux));
                    {
                        best=dista_euclid(v1[i],aux);
                        ind=j;
                    }
                }
                coords ans;
                ans.x=v1[i-1].x;
                ans.y=ind;
                mp[2][make_pair(v1[i].x,v1[i].y)]=ans;
            }
            else
                mp[2][make_pair(v1[i].x,v1[i].y)]=v1[i-1];
            if(samey[v2[i-1].y].size()>1)
            {
                long double best=-INF;
                long double ind=0;
                for(auto j:samey[v2[i-1].y])
                {
                    if(j==v2[i].x)
                        continue;
                    coords aux;
                    aux.x=j;
                    aux.y=v2[i-1].y;
                    if(best>dista_euclid(v2[i],aux));
                    {
                        best=dista_euclid(v2[i],aux);
                        ind=j;
                    }
                }
                coords ans;
                ans.x=ind;
                ans.y=v2[i-1].y;
                mp[4][make_pair(v2[i].x,v2[i].y)]=ans;
            }
            else
                mp[4][make_pair(v2[i].x,v2[i].y)]=v2[i-1];
        }
        if(i!=n)
        {
            if(samex[v1[i+1].x].size()>1)
            {
                long double best=-INF;
                long double ind=0;
                for(auto j:samex[v1[i+1].x])
                {
                    if(j==v1[i].y)
                        continue;
                    coords aux;
                    aux.x=v1[i+1].x;
                    aux.y=j;
                    if(best>dista_euclid(v1[i],aux));
                    {
                        best=dista_euclid(v1[i],aux);
                        ind=j;
                    }
                }
                coords ans;
                ans.x=v1[i-1].x;
                ans.y=ind;
                mp[1][make_pair(v1[i].x,v1[i].y)]=ans;
            }
            else
                mp[1][make_pair(v1[i].x,v1[i].y)]=v1[i+1];
            if(samey[v2[i+1].y].size()>1)
            {
                long double best=-INF;
                long double ind=0;
                for(auto j:samey[v2[i+1].y])
                {
                    if(j==v2[i].x)
                        continue;
                    coords aux;
                    aux.x=j;
                    aux.y=v2[i+1].y;
                    if(best>dista_euclid(v2[i],aux));
                    {
                        best=dista_euclid(v2[i],aux);
                        ind=j;
                    }
                }
                coords ans;
                ans.x=ind;
                ans.y=v2[i+1].y;
                mp[3][make_pair(v2[i].x,v2[i].y)]=ans;
            }
            else
                mp[3][make_pair(v2[i].x,v2[i].y)]=v2[i+1];
        }
    }
    for(i=1;i<=n;i++)
    {
            if(diff(v[i].x,v[i].y,1) && diff(v[i].x,v[i].y,2) && (mp[1][make_pair(v[i].x,v[i].y)].x!=mp[2][make_pair(v[i].x,v[i].y)].x || mp[1][make_pair(v[i].x,v[i].y)].y!=mp[2][make_pair(v[i].x,v[i].y)].y))
                mini=min(mini,solve_perimeter(v[i],mp[1][make_pair(v[i].x,v[i].y)],mp[2][make_pair(v[i].x,v[i].y)]));
            if(diff(v[i].x,v[i].y,1) && diff(v[i].x,v[i].y,3) && (mp[1][make_pair(v[i].x,v[i].y)].x!=mp[3][make_pair(v[i].x,v[i].y)].x || mp[1][make_pair(v[i].x,v[i].y)].y!=mp[3][make_pair(v[i].x,v[i].y)].y))
                mini=min(mini,solve_perimeter(v[i],mp[1][make_pair(v[i].x,v[i].y)],mp[3][make_pair(v[i].x,v[i].y)]));
            if(diff(v[i].x,v[i].y,1) && diff(v[i].x,v[i].y,4) && (mp[1][make_pair(v[i].x,v[i].y)].x!=mp[4][make_pair(v[i].x,v[i].y)].x || mp[1][make_pair(v[i].x,v[i].y)].y!=mp[4][make_pair(v[i].x,v[i].y)].y))
                mini=min(mini,solve_perimeter(v[i],mp[1][make_pair(v[i].x,v[i].y)],mp[4][make_pair(v[i].x,v[i].y)]));
            if(diff(v[i].x,v[i].y,2) && diff(v[i].x,v[i].y,3) && (mp[2][make_pair(v[i].x,v[i].y)].x!=mp[3][make_pair(v[i].x,v[i].y)].x || mp[2][make_pair(v[i].x,v[i].y)].y!=mp[3][make_pair(v[i].x,v[i].y)].y))
                mini=min(mini,solve_perimeter(v[i],mp[2][make_pair(v[i].x,v[i].y)],mp[3][make_pair(v[i].x,v[i].y)]));
            if(diff(v[i].x,v[i].y,2) && diff(v[i].x,v[i].y,4) && (mp[2][make_pair(v[i].x,v[i].y)].x!=mp[4][make_pair(v[i].x,v[i].y)].x || mp[2][make_pair(v[i].x,v[i].y)].y!=mp[4][make_pair(v[i].x,v[i].y)].y))
                mini=min(mini,solve_perimeter(v[i],mp[2][make_pair(v[i].x,v[i].y)],mp[4][make_pair(v[i].x,v[i].y)]));
            if(diff(v[i].x,v[i].y,3) && diff(v[i].x,v[i].y,4) && (mp[3][make_pair(v[i].x,v[i].y)].x!=mp[4][make_pair(v[i].x,v[i].y)].x || mp[3][make_pair(v[i].x,v[i].y)].y!=mp[4][make_pair(v[i].x,v[i].y)].y))
                mini=min(mini,solve_perimeter(v[i],mp[3][make_pair(v[i].x,v[i].y)],mp[4][make_pair(v[i].x,v[i].y)]));
    }
    cout<<fixed<<setprecision(7)<<mini;
    return 0;
}