#include <iostream>
#include <vector>
#include <algorithm>

const int MAX_N = 200000;

int v[MAX_N];
bool vis[MAX_N];

int main() {
  int n, k;

  std::cin >> n >> k;
  for (int i = 0; i < n; ++i) {
    std::cin >> v[i];
    v[i]--;
  }

  std::vector<int> cycles;

  for (int i = 0; i < n; ++i) {
    int len = 0;
    int node = i;

    while (!vis[node]) {
      vis[node] = true;
      node = v[node];
      len++;
    }

    if (len != 0)
      cycles.push_back(len);
    
    // If we already have a team of size k, then we don't have to do anything
    if (len == k) {
      std::cout << 0 << "\n";
      return 0;
    }
  }


  std::sort(cycles.rbegin(), cycles.rend());

  int i = 0;
  int sol = 0;

  // We have to merge some cycles to get to k. To merge two cycles,
  // make one of the cats from one cycle to point to the other. This will lead to
  // a long array that ends in a cycle. We choose the team captain from the tail
  // of this structure.
  while (k > 0) {
    k -= cycles[i];
    sol++;
    i++;
  }
  sol--;

  std::cout << sol << "\n";

  return 0;
}

