#include <iostream>
#include <vector>
#include <algorithm>

const int MAX_N = 200000;

int v[MAX_N];
bool vis[MAX_N];

/*
 * This solution was intended to fail on a test where the answer is 0.
 * I thought that such test was missing, but I saw that there was a
 * test checking this and my solution actually works.
 *
 * On the other hand, this solution should still fail on a permutation
 * that has a cycle of length k and a cycle of length bigger than k. My
 * program will print 1 instead of 0.
 */

int main() {
  int n, k;

  std::cin >> n >> k;
  for (int i = 0; i < n; ++i) {
    std::cin >> v[i];
    v[i]--;
  }

  std::vector<int> cycles;

  for (int i = 0; i < n; ++i) {
    int len = 0;
    int node = i;

    while (!vis[node]) {
      vis[node] = true;
      node = v[node];
      len++;
    }

    if (len != 0)
      cycles.push_back(len);
  }


  std::sort(cycles.rbegin(), cycles.rend());

  int i = 0;
  int sol = 0;

  // If we have a cycle bigger than k, we can just break. Set one of the cats to 
  // itself. Basically, we turned this cycle into an array, so we can choose the
  // team captain.
  if (cycles[0] > k)
    sol = 1;
  else {
    // If all the cycles are smaller, then we have to merge them. To merge to cycles,
    // make one of the cats from one cycle to point to the other. This will lead to
    // a long array that ends in a cycle. We choose the team captain from the tail
    // of this structure.
    while (k > 0) {
      k -= cycles[i];
      sol++;
      i++;
    }
    sol--;
  }

  std::cout << sol << "\n";

  return 0;
}

